<CsoundSynthesizer>
<CsOptions>
-o formant_filter.wav -W
</CsOptions>
; ==============================================
<CsInstruments>

sr	=	48000
ksmps	=	1
nchnls	=	2
0dbfs	=	1

#include "m_formant.udo"

instr 1	
	kpitch = cpsmidinn(p4) ; pitch of this note (m_formant works with MIDI notes)
	imode init 0 ; Mode of VCO2 (sawtooth)
	avco vco2 1, kpitch, imode, 0.5

	; Set up parameters for the formant filter
	kkeytrack init 1 ; 100% keytracking of formants
	kresonance init 1 ; Resonance/mix of the filter at full
	kregister init p5
	kvowel linseg 2, .1, 1, .2, 2, p3-.3, 2 ; Say i-e-i (yay)
	ifreq init 1
	iamp init 2
	ibw init 3
	itrack init 4
	ivowel init 5
	aform m_formant p4, kkeytrack, avco, kresonance, kregister, kvowel, \
		ifreq, iamp, ibw, itrack, ivowel
	outs aform, aform
endin

</CsInstruments>
; ==============================================
<CsScore>
f1 0 125 -23 "formfilt_freq.ftable"
f2 0 125 -23 "formfilt_amp.ftable"
f3 0 125 -23 "formfilt_bw.ftable"
f4 0 128 -23 "formfilt_reg.ftable"
f5 0 32 -23 "formfilt_vowel.ftable"

i1 0 2 36 2
i1 + . 39 2
i1 . . 43 2
i1 . . 48 3
i1 . . 51 3
i1 . . 55 3
i1 . . 59 4
i1 . . 60 4
e
</CsScore>
</CsoundSynthesizer>

